# Dopia

* train: contains training applications

* test: contains test applications

* armcl:
  * compiler(prep): the preprocessor that performs code generation for
  advanced resource management

  * runtime(runtime): the runtime resource manager that performs
  advanced resource management through library interpositioning

We aim at improving platform efficiency through
our resource management techniques.
We also aim at an OpenCL framework that leverages existing OpenCL frameworks
(e.g., Intel/AMD OpenCL, SnuCL) but has no implementation dependencies.

## How to install?
1. $ cd armcl
2. $ source ./env.sh 
3. $ cd runtime/
4. $ make

## How to use our framework?
- set environment variables ($ source env.sh) before executing an application.

### Train
- execute run\_mat3dadd.py and run\_mat4dadd.py on train directory to collect data.
- execute analysis.py to make training data file for model.

### Test
- execute an application while linking libArmCL.so (LD\_PRELOAD)
- command example: `sudo -E LD_PRELOAD=$ARMCL_ROOT/lib/libArmCL.so METHOD=DynCoRun ./ATAX 16384 64 64 256`
