//------------------------------------------------------------------------------
// ARM OpenCL Runtime
//
// Copyright (c) 2017 Computer Systems and Platforms Laboratory.
// All right reserved.
//
// Author:
// Younghyun Cho <younghyun@csap.snu.ac.kr>
//

#ifndef __ARM_OpenCL_HEADER_
#define __ARM_OpenCL_HEADER_

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#include <CL/cl.h>

#include <cstdio>
#include <cstdlib>
#include <iostream>

#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>

#include <arpa/inet.h>
#include <string.h>

#include <fcntl.h>
#include <dlfcn.h>

#include <map>
#include "ArmCLContext.hpp"
#include "ArmCLCommandQueue.hpp"
#include "ArmCLProgram.hpp"
#include "ArmCLBuffer.hpp"
#include "ArmCLKernel.hpp"

std::map<cl_context, ArmCLContext*> armcl_contexts;
std::map<cl_command_queue, ArmCLCommandQueue*> armcl_command_queues;
std::map<cl_program, ArmCLProgram*> armcl_programs;
std::map<cl_kernel, ArmCLKernel*> armcl_kernels;
std::map<cl_mem, ArmCLBuffer*> armcl_buffers;

ArmCLContext *context;

#ifdef __cplusplus
extern "C" {
#endif
int __libc_start_main(int (*main) (int, char **, char **),
        int argc,
        char **ubp_av,
        void (*init) (void),
        void (*fini) (void),
        void (*rtld_fini) (void),
        void (*stack_end));

void exit(int status);

#ifdef __cplusplus
}
#endif

#endif
