//------------------------------------------------------------------------------
// ARM OpenCL Runtime
//
// Copyright (c) 2017 Computer Systems and Platforms Laboratory.
// All right reserved.
//
// Author:
// Younghyun Cho <younghyun@csap.snu.ac.kr>
//

#include "ArmCLProgram.hpp"

ArmCLProgram::ArmCLProgram(cl_program program, ArmCLContext* armcl_context)
    : program_(program), armcl_context_(armcl_context)
{
    PrepareOpenCLCalls();
}

ArmCLProgram::~ArmCLProgram()
{
}

void ArmCLProgram::SetBuildOptions(const char* options)
{
    strncpy(build_option_, options, strlen(options));
}

void ArmCLProgram::RegisterKernels(ArmCLKernel* armcl_kernel)
{
    armcl_kernels_.push_back(armcl_kernel);
}

void ArmCLProgram::PreprocessingWithSource(const char ** strings,
        const size_t * lengths,
        char ** generated_strings,
        size_t * generated_lengths)
{
#ifdef DEBUG
    std::cout << "ArmCL: "
        << " preprocessing with source"
        << std::endl;
#endif
}

void ArmCLProgram::PrepareOpenCLCalls()
{
    char* error;

    clBuildProgram_p_ = (cl_int CL_API_CALL (*) (cl_program program,
                cl_uint num_devices,
                const cl_device_id* device_list,
                const char* options,
                void (CL_CALLBACK * pfn_notify)(cl_program program,
                    void* user_data),
                void* user_data))dlsym(RTLD_NEXT, "clBuildProgram");
    if ((error = dlerror()) != NULL) {
        fputs(error, stderr);
        exit(1);
    }
}
