//------------------------------------------------------------------------------
// ARM OpenCL Runtime
//
// Copyright (c) 2017 Computer Systems and Platforms Laboratory.
// All right reserved.
//
// Author:
// Younghyun Cho <younghyun@csap.snu.ac.kr>
//

#ifndef __ARM_OpenCL_Program_HEADER_
#define __ARM_OpenCL_Program_HEADER_

#include <CL/cl.h>
#include <iostream>
#include <string>
#include <vector>
#include <stdio.h>
#include <cstdlib>
#include <string.h>

#include <dlfcn.h>
#include <stdio.h>

//#include "ArmCLKernel.hpp"
#include "ArmCLContext.hpp"

class ArmCLContext;
class ArmCLKernel;

class ArmCLProgram {
  public:
    ArmCLProgram(cl_program program, ArmCLContext* armcl_context);
    ~ArmCLProgram();

    cl_program program() const { return program_; }

    ArmCLContext* armcl_context() const { return armcl_context_; }

    void SetBuildOptions(const char* options);
    char* build_option(void) { return build_option_; }

    void RegisterKernels(ArmCLKernel* kernel);

    void PreprocessingWithSource(const char ** strings,
            const size_t * lengths,
            char ** generated_strings,
            size_t * generated_lengths);

  private:
    void PrepareOpenCLCalls();

    std::vector<ArmCLKernel*> armcl_kernels_;

    char build_option_[256] = { 0, };

    cl_program program_;

    ArmCLContext* armcl_context_;

    cl_int CL_API_CALL (*clBuildProgram_p_) (cl_program program,
            cl_uint num_devices,
            const cl_device_id* device_list,
            const char* options,
            void (CL_CALLBACK * pfn_notify)(cl_program program,
                void* user_data),
            void* user_data);

};

#endif
