/// PMU interface
/// Author: Younghyun Cho <younghyun@csap.snu.ac.kr>

#ifndef __PMU_INTERFACE_H_
#define __PMU_INTERFACE_H_

//#include <cstdlib>
#include <stdlib.h>
#include <unistd.h>
#include <linux/perf_event.h>
#include <sys/epoll.h>
//#include <mutex>

//#include <tuple>
#include <list>
#include "event.h"

class PMUReqManager {
  public:
    PMUReqManager();
    ~PMUReqManager();

    void InitPerfEventAttr();
    void InitPerfEventAttr(
        std::pair<__u32, __u64>* attr_mapping,
        event_type* attr_type,
        int num_events);

    void GetCurrentCount(sc_event_values& val);
    void GetCurrentCount(sc_event_values& val,
        unsigned long* values);

    void OpenEventFDs();

    void OpenEventFDs(int subset_index);
    void OpenEventFDsByPID(pid_t pid);

    void CloseEventFDs();
    void CloseEventFDs(int subset_index);

    void RecordAllCounters();

  private:
    void ReadCounters(sc_event_values *values);

    int _fd[MAX_EVENTS][NUM_CORES]; ///< event-perf file descriptors
    struct perf_event_attr _attr[MAX_EVENTS]; ///< event-perf attributes
    event_type _event_type[MAX_EVENTS]; ///< event type information
    sc_event_values _cur; ///< recently stored count values
    //std::mutex _cur_mutex;
};

#endif

