#include "event.h"
#include "pmu_interface.h"
#include "profiler.h"
#include "profiler_interface.h"

AMDProfiler* profiler;

void CreateSingleMemoryProfiler()
{
    profiler = new MCTProfiler(1);
}

void CreateMCTProfiler(int num_memories)
{
    profiler = new MCTProfiler(num_memories);
}

void CreateDCTProfiler(int dct_num, int num_memories)
{
    profiler = new DCTProfiler(dct_num, num_memories);
}

void StartProfiling(void)
{
    profiler->StartProfiling();
}

void StopProfiling(char* prefix, char* path)
{
    std::string prefix_str(prefix);
    std::string path_str(path);
    profiler->StopProfiling(prefix_str, path_str);
}

void ReleaseProfiler(void)
{
    delete profiler;
}
