#!/usr/bin/env python

from os.path import exists
import os
import sys

import commands
import re

number_re = "+([0-9]+\.[01-9]+|[0-9]+)"

def get_values(log, prefix):
    try:
        val = re.findall(prefix+number_re, log)[0]
        return val
    except:
        return "-1.0"

def get_values_idx(log, prefix, idx):
    try:
        val = re.findall(prefix+number_re, log)[idx]
        return val
    except:
        return "-1.0"

os.system("sudo rm profiling.txt")

for data_type in ["f","d","i"]:
    for computation in ["c0","c1","c2","c4","c8","c16"]:
        file_name = "mat2dadd." + data_type + ".d1." + computation + ".train.data"
        if exists(file_name):
            continue
        f = open(file_name, "w")
        f.write("#NI,NJ,GS_X,GS_Y,LS_X,LS_Y,CPU,GPU,elapsed_time,llc_misses,mct_reads,mct_prefetches,mct_writes,processed_wgs_cpu\n")
        for N in [4096]:
            NI = N
            NJ = N

            GS_X = NI
            for LS_X in [64]:
                for num_cpu_cores in range(0, 5, 1):
                    throttling_mod = 8
                    for throttling_alloc in range(0, 9, 1):
                        if num_cpu_cores == 0 and throttling_alloc == 0:
                            continue
                        if num_cpu_cores == 0 and gpu_percent != 100:
                            continue
                        if throttling_alloc == 0 and gpu_percent != 0:
                            continue
                        if num_cpu_cores != 0 and gpu_percent == 100:
                            continue
                        if throttling_alloc != 0 and gpu_percent == 0:
                            continue

                        command = "sudo ./mat2dadd-" + data_type + "-d1-" + computation + " " + \
                                str(num_cpu_cores) + " " + \
                                str(throttling_mod) + " " + \
                                str(throttling_alloc) + " " + \
                                str(NI) + " " + \
                                str(NJ) + " " + \
                                str(LS_X)

                        print command
                        output = commands.getoutput(command)

                        profiling_f = open("profiling.txt", "r")
                        log = profiling_f.read()
                        profiling_f.close()

                        elapsed_time = get_values(log, "mat2dadd_elapsed_time: ")
                        llc_misses = get_values(log, "mat2dadd_llc_misses: ")
                        mct_reads = get_values(log, "mat2dadd_sum_mct_read_requests: ")
                        mct_prefetches = get_values(log, "mat2dadd_sum_mct_prefetch_requests: ")
                        mct_writes = get_values(log, "mat2dadd_sum_mct_write_requests: ")

                        processed_wgs_cpu = 0
                        #for i in range(0,num_cpu_cores):
                        #    processed_wgs_cpu += int(get_values(output, "thread"+str(i)+": "))

                        print str(NI) + "," + str(NJ) + "," + \
                              str(GS_X) + ",0," + str(LS_X) + ",0," + \
                              str(num_cpu_cores) + "," + str(throttling_alloc*(100/throttling_mod)) + "," + \
                              str(elapsed_time) + "," + str(llc_misses) + "," + \
                              str(mct_reads) + "," + str(mct_prefetches) + "," + str(mct_writes) + "," + \
                              str(processed_wgs_cpu) + "\n"

                        f.write(str(NI) + "," + str(NJ) + "," + \
                                str(GS_X) + ",0," + str(LS_X) + ",0," + \
                                str(num_cpu_cores) + "," + str(throttling_alloc*(100/throttling_mod)) + "," + \
                                str(elapsed_time) + "," + str(llc_misses) + "," + \
                                str(mct_reads) + "," + str(mct_prefetches) + "," + str(mct_writes) + "," + \
                                str(processed_wgs_cpu) + "\n")

                        os.system("sudo rm profiling.txt")
        f.close()
