#!/usr/bin/env python

from os.path import exists
import os
import sys

import commands
import re

number_re = "+([0-9]+\.[01-9]+|[0-9]+)"

def get_values(log, prefix):
    try:
        val = re.findall(prefix+number_re, log)[0]
        return val
    except:
        return "-1.0"

def get_values_idx(log, prefix, idx):
    try:
        val = re.findall(prefix+number_re, log)[idx]
        return val
    except:
        return "-1.0"


if exists("profiling.txt"):
    os.system("sudo rm profiling.txt")

applications = ["bandwidth-f-d1-c0"]
config_1D = [
    [8192, 128, 64, 256],
    [8192, 128, 64, 128],
    [8192, 128, 64, 64],
    [8192, 128, 64, 32],
    [8192, 256, 32, 256],
    [8192, 256, 32, 128],
    [8192, 256, 32, 64],
    [8192, 256, 32, 32],
    [4096, 256, 128, 256],
    [4096, 256, 128, 128],
    [4096, 256, 128, 64],
    [4096, 256, 128, 32],
    [4096, 256, 128, 16],
    [2048, 256, 256, 256],
    [2048, 256, 256, 128],
    [2048, 256, 256, 64],
    [2048, 256, 256, 32],
    [2048, 256, 256, 16],
    [2048, 256, 256, 8],
]
config_2D = [
    [4096, 4096, 4, 128, 2],
    [4096, 4096, 4, 64, 4],
    [4096, 4096, 4, 32, 8],
    [4096, 4096, 4, 16, 16],
    [4096, 4096, 4, 8, 8],
    [4096, 4096, 4, 4, 4],
    [4096, 4096, 4, 2, 2],
    [2048, 2048, 16, 128, 2],
    [2048, 2048, 16, 64, 4],
    [2048, 2048, 16, 32, 8],
    [2048, 2048, 16, 16, 16],
    [2048, 2048, 16, 8, 8],
    [2048, 2048, 16, 4, 4],
    [2048, 2048, 16, 2, 2],
    [1024, 1024, 32, 128, 2],
    [1024, 1024, 32, 64, 4],
    [1024, 1024, 32, 32, 8],
    [1024, 1024, 32, 16, 16],
    [1024, 1024, 32, 8, 8],
    [1024, 1024, 32, 4, 4],
    [1024, 1024, 32, 2, 2],
    [1024, 1024, 32, 1, 1],
]
config_3D = [
    [512,512,256,256,1,1],
    [512,512,256,128,2,1],
    [512,512,256,64,4,1],
    [512,512,256,64,2,2],
    [512,512,256,32,8,1],
    [512,512,256,32,4,2],
    [512,512,256,16,16,1],
    [512,512,256,16,8,2],
    [512,512,256,16,4,4],
    [512,512,256,8,8,4],
]

threads = [" 4 4 0 ", " 4 4 4 ", " 0 4 4 "]

for data_type in ["f"]:
    for computation in ["c0"]:
        file_name = "mat3dadd." + data_type + ".d1." + computation + ".time.data"
        f = open(file_name, "w")
        f.write("#NI,NJ,NK,LS_X,LS_Y,LS_Z,CPU,CPU+GPU,GPU\n")
        for i in range(0,len(config_1D)):
            NI = config_1D[i][0]
            NJ = config_1D[i][1]
            NK = config_1D[i][2]
            #GS_X = config_1D[i][3]
            LS_X = config_1D[i][3]
            f.write(str(NI) + "," + str(NJ) + "," + str(NK) + "," + \
                    str(LS_X) + ",1,1,")

            for j in range(0,3):
                command = "sudo ./mat3dadd-" + data_type + "-d1-" + computation + \
                        threads[j] + \
                        str(NI) + " " + \
                        str(NJ) + " " + \
                        str(NK) + " " + \
                        str(LS_X)

                print command
                print "\n"
                output = commands.getoutput(command)

                profiling_f = open("profiling.txt", "r")
                log = profiling_f.read()
                profiling_f.close()

                elapsed_time = get_values(log, "mat3dadd_elapsed_time: ")

                #processed_wgs_cpu = 0
                #for i in range(num_cpu_cores):
                #    processed_wgs_cpu += int(get_values(output, "thread"+str(i)+": "))

                f.write(str(elapsed_time) + ",")

                os.system("sudo rm profiling.txt")

            f.write("\n")
        f.close()

for data_type in ["f"]:
    for computation in ["c0"]:
        file_name = "mat3dadd." + data_type + ".d2." + computation + ".time.data"
        f = open(file_name, "w")
        f.write("#NI,NJ,NK,LS_X,LS_Y,LS_Z,CPU,CPU+GPU,GPU\n")
        for i in range(0,len(config_2D)):
            NI = config_2D[i][0]
            NJ = config_2D[i][1]
            NK = config_2D[i][2]
            #GS_X = config_1D[i][3]
            LS_X = config_2D[i][3]
            LS_Y = config_2D[i][4]
            f.write(str(NI) + "," + str(NJ) + "," + str(NK) + "," + \
                    str(LS_X) + "," + str(LS_Y) +  ",1,")

            for j in range(0,3):
                command = "sudo ./mat3dadd-" + data_type + "-d1-" + computation + \
                        threads[j] + \
                        str(NI) + " " + \
                        str(NJ) + " " + \
                        str(NK) + " " + \
                        str(LS_X) + " " + \
                        str(LS_Y)

                print command
                print "\n"
                output = commands.getoutput(command)

                profiling_f = open("profiling.txt", "r")
                log = profiling_f.read()
                profiling_f.close()

                elapsed_time = get_values(log, "mat3dadd_elapsed_time: ")

                #processed_wgs_cpu = 0
                #for i in range(num_cpu_cores):
                #    processed_wgs_cpu += int(get_values(output, "thread"+str(i)+": "))

                f.write(str(elapsed_time) + ",")

                os.system("sudo rm profiling.txt")

            f.write("\n")
        f.close()

for data_type in ["f"]:
    for computation in ["c0"]:
        file_name = "mat3dadd." + data_type + ".d3." + computation + ".time.data"
        f = open(file_name, "w")
        f.write("#NI,NJ,NK,LS_X,LS_Y,LS_Z,CPU,CPU+GPU,GPU\n")
        for i in range(0,len(config_3D)):
            NI = config_3D[i][0]
            NJ = config_3D[i][1]
            NK = config_3D[i][2]
            #GS_X = config_1D[i][3]
            LS_X = config_3D[i][3]
            LS_Y = config_3D[i][4]
            LS_Z = config_3D[i][5]
            f.write(str(NI) + "," + str(NJ) + "," + str(NK) + "," + \
                    str(LS_X) + "," + str(LS_Y) + "," + str(LS_X))

            for j in range(0,3):
                command = "sudo ./mat3dadd-" + data_type + "-d1-" + computation + \
                        threads[j] + \
                        str(NI) + " " + \
                        str(NJ) + " " + \
                        str(NK) + " " + \
                        str(LS_X) + " " + \
                        str(LS_Y) + " " + \
                        str(LS_Z)

                print command
                print "\n"
                output = commands.getoutput(command)

                profiling_f = open("profiling.txt", "r")
                log = profiling_f.read()
                profiling_f.close()

                elapsed_time = get_values(log, "mat3dadd_elapsed_time: ")

                #processed_wgs_cpu = 0
                #for i in range(num_cpu_cores):
                #    processed_wgs_cpu += int(get_values(output, "thread"+str(i)+": "))

                f.write(str(elapsed_time) + ",")

                os.system("sudo rm profiling.txt")

            f.write("\n")
        f.close()
