#!/usr/bin/env python

from os.path import exists
import os
import sys

import commands
import re

import multiprocessing

number_re = "+([0-9]+\.[01-9]+|[0-9]+)"

def get_values(log, prefix):
    try:
        val = re.findall(prefix+number_re, log)[0]
        return val
    except:
        return "-1.0"

def get_values_idx(log, prefix, idx):
    try:
        val = re.findall(prefix+number_re, log)[idx]
        return val
    except:
        return "-1.0"

if __name__ == "__main__":
    totalcores = multiprocessing.cpu_count()

    for experiment in ["1Mat4DAdd", "1Mat4DAdd1R", "1Mat4DAdd1T", "1Mat4DAddC", "1Mat4DAddC1R" ,"1Mat4DAddC1T", "2Mat4DAdd", "2Mat4DAdd1R", "2Mat4DAdd1T", "2Mat4DAdd1R1T", "2Mat4DAddC", "2Mat4DAddC1R", "2Mat4DAddC1T", "2Mat4DAddC1R1T"]:
        os.chdir(experiment)
        os.system("make clean")
        os.system("rm *.so")
        if not exists("dataset"):
            os.system("mkdir -p dataset")
        os.system("make")

        for datatype in ["f","i"]:
            for computation in ["c0","c4","c16"]:
                for workdim in [1,2,3]:
                    if workdim == 1:
                        #for N in [16384,32768,65536]:
                        for N in [16384,32768]:
                            for work_config in [1,2]:
                            #for work_config in [2]:
                                file_name = "mat4dadd." + datatype + ".d1." + computation + "." + str(N) + "." + str(workdim) + "." + str(work_config) + ".train.data"
                                if not exists("dataset/"+file_name):
                                    f = open("dataset/"+file_name, "w")
                                    f.write("workdim,globalsize,localsize,cpucores,gpucores,elapsedtime,memoryreqs\n")

                                    NI, NJ, NK, NM = N, 16, 16, 16
                                    LS0, LS1, LS2 = 0, 0, 0
                                    if work_config is 1:
                                        LS0, LS1, LS2 = 64, 0, 0
                                    elif work_config is 2:
                                        LS0, LS1, LS2 = 256, 0, 0

                                    for cpucores in range(0, totalcores+1, 1):
                                        throttling_mod = 8
                                        for throttling_alloc in range(0, 9, 1):
                                            if cpucores == 0 and throttling_alloc == 0: continue
                                            if exists("profiling.txt"):
                                                os.system("rm profiling.txt")

                                            command = "LD_PRELOAD=/home/younghyun/Research/armcl/lib/libArmCL.so" + \
                                                      " " + "METHOD=DynCoRun" + \
                                                      " " + "NUM_CPU_CORES=" + str(cpucores) + \
                                                      " " + "THROTTLING_MOD=" + str(throttling_mod) + \
                                                      " " + "THROTTLING_ALLOC=" + str(throttling_alloc) + \
                                                      " " + "./mat4dadd-" + datatype + "-d1-" + computation + \
                                                      " " + str(NI) + \
                                                      " " + str(NJ) + \
                                                      " " + str(NK) + \
                                                      " " + str(NM) + \
                                                      " " + str(LS0)
                                            print experiment
                                            print command
                                            output = commands.getoutput(command)
                                            print output

                                            profiling_f = open("profiling.txt", "r")
                                            log = profiling_f.read()
                                            profiling_f.close()

                                            globalsize = NI
                                            localsize = LS0
                                            cpuresource = cpucores
                                            gpuresource = float(throttling_alloc) / float(throttling_mod)
                                            elapsedtime = get_values(log, "mat4dadd_elapsed_time: ")
                                            memoryreqs = get_values(log, "mat4dadd_node_0_total_memory_controller_requests: ")

                                            f.write(str(workdim) + "," + str(globalsize) + "," + str(localsize) + "," + \
                                                    str(cpuresource) + "," + str(gpuresource) + "," + str(elapsedtime) + "," + str(memoryreqs) + "\n")
                                    f.close()
                    elif workdim == 2:
                        for N in [128, 256, 512]:
                            for work_config in [1,2]:
                            #for work_config in [2]:
                                file_name = "mat4dadd." + datatype + ".d2." + computation + "." + str(N) + "." + str(workdim) + "." + str(work_config) + ".train.data"
                                if not exists("dataset/"+file_name):
                                    f = open("dataset/"+file_name, "w")
                                    f.write("workdim,globalsize,localsize,cpucores,gpucores,cpuwork,gpuwork,elapsedtime,memoryreqs\n")

                                    NI, NJ, NK, NM = N, N, 32, 32
                                    LS0, LS1, LS2 = 0, 0, 0
                                    if work_config is 1:
                                        LS0, LS1, LS2 = 8, 8, 0
                                    elif work_config is 2:
                                        LS0, LS1, LS2 = 16, 16, 0

                                    for cpucores in range(0, totalcores+1, 1):
                                        throttling_mod = 8
                                        for throttling_alloc in range(0, 9, 1):
                                            if cpucores == 0 and throttling_alloc == 0: continue
                                            if exists("profiling.txt"):
                                                os.system("rm profiling.txt")

                                            command = "LD_PRELOAD=/home/younghyun/Research/armcl/lib/libArmCL.so" + \
                                                    " " + "METHOD=DynCoRun" + \
                                                    " " + "NUM_CPU_CORES=" + str(cpucores) + \
                                                    " " + "THROTTLING_MOD=" + str(throttling_mod) + \
                                                    " " + "THROTTLING_ALLOC=" + str(throttling_alloc) + \
                                                    " " + "./mat4dadd-" + datatype + "-d2-" + computation + \
                                                    " " + str(NI) + \
                                                    " " + str(NJ) + \
                                                    " " + str(NK) + \
                                                    " " + str(NM) + \
                                                    " " + str(LS0) + \
                                                    " " + str(LS1)
                                            print experiment
                                            print command
                                            output = commands.getoutput(command)
                                            print output

                                            profiling_f = open("profiling.txt", "r")
                                            log = profiling_f.read()
                                            profiling_f.close()

                                            globalsize = NI * NJ
                                            localsize = LS0 * LS1
                                            cpuresource = cpucores
                                            gpuresource = float(throttling_alloc) / float(throttling_mod)
                                            elapsedtime = get_values(log, "mat4dadd_elapsed_time: ")
                                            memoryreqs = get_values(log, "mat4dadd_node_0_total_memory_controller_requests: ")

                                            f.write(str(workdim) + "," + str(globalsize) + "," + str(localsize) + "," + \
                                                    str(cpuresource) + "," + str(gpuresource) + "," + str(elapsedtime) + "," + str(memoryreqs) + "\n")
                                    f.close()
                    elif workdim == 3:
                        for N in [128, 256, 512]:
                            for work_config in [1,2]:
                            #for work_config in [2]:
                                file_name = "mat4dadd." + datatype + ".d3." + computation + "." + str(N) + "." + str(workdim) + "." + str(work_config) + ".train.data"
                                if not exists("dataset/"+file_name):
                                    f = open("dataset/"+file_name, "w")
                                    f.write("workdim,globalsize,localsize,cpucores,gpucores,cpuwork,gpuwork,elapsedtime,memoryreqs\n")

                                    NI, NJ, NK, NM = N, N, 32, 32
                                    LS0, LS1, LS2 = 0, 0, 0
                                    if work_config is 1:
                                        LS0, LS1, LS2 = 4, 4, 4
                                    elif work_config is 2:
                                        LS0, LS1, LS2 = 8, 8, 4

                                    for cpucores in range(0, totalcores+1, 1):
                                        throttling_mod = 8
                                        for throttling_alloc in range(0, 9, 1):
                                            if cpucores == 0 and throttling_alloc == 0: continue
                                            if exists("profiling.txt"):
                                                os.system("rm profiling.txt")

                                            command = "LD_PRELOAD=/home/younghyun/Research/armcl/lib/libArmCL.so" + \
                                                    " " + "METHOD=DynCoRun" + \
                                                    " " + "NUM_CPU_CORES=" + str(cpucores) + \
                                                    " " + "THROTTLING_MOD=" + str(throttling_mod) + \
                                                    " " + "THROTTLING_ALLOC=" + str(throttling_alloc) + \
                                                    " " + "./mat4dadd-" + datatype + "-d3-" + computation + \
                                                    " " + str(NI) + \
                                                    " " + str(NJ) + \
                                                    " " + str(NK) + \
                                                    " " + str(NM) + \
                                                    " " + str(LS0) + \
                                                    " " + str(LS1) + \
                                                    " " + str(LS2)
                                            print experiment
                                            print command
                                            output = commands.getoutput(command)
                                            print output

                                            profiling_f = open("profiling.txt", "r")
                                            log = profiling_f.read()
                                            profiling_f.close()

                                            globalsize = NI * NJ * NK
                                            localsize = LS0 * LS1 * LS2
                                            cpuresource = cpucores
                                            gpuresource = float(throttling_alloc) / float(throttling_mod)
                                            elapsedtime = get_values(log, "mat4dadd_elapsed_time: ")
                                            memoryreqs = get_values(log, "mat4dadd_node_0_total_memory_controller_requests: ")

                                            f.write(str(workdim) + "," + str(globalsize) + "," + str(localsize) + "," + \
                                                    str(cpuresource) + "," + str(gpuresource) + "," + str(elapsedtime) + "," + str(memoryreqs) + "\n")
                                    f.close()
        os.chdir("..")

